class Device { 
  int pendingIo; 
  boolean stoppingFlag; 
  boolean stoppingEvent; 
  boolean stopped; 
  
  Device() { 
    pendingIo = 1; 
    stoppingFlag = false; 
    stoppingEvent = false; 
    stopped = false; 
  } 
}
 
class Bluetooth { 
  static void add(Device d) { 
    int status = inc(d); 
    if (status > 0) { 
      assert(!d.stopped); 
      // Performs I/O 
    } 
    dec(d); 
  } 

  static void stop(Device d) { 
    d.stoppingFlag = true; 
    dec(d); 
    while (!d.stoppingEvent) {} 
    d.stopped = true; 
  }
 
  static int inc(Device d) { 
    int status; 
    synchronized(d) { 
      d.pendingIo++; 
    } 
    if (d.stoppingFlag) { 
      dec(d); 
      status = -1; 
    } else status = 1; 
      return status; 
    } 

  static void dec(Device d) { 
    int pio; 
    synchronized (d) { 
      d.pendingIo--; 
      pio = d.pendingIo; 
    } 
    if (pio == 0) 
      d.stoppingEvent = true; 
  } 
}
