
import java.util.Random;

/**
 * A binary search tree implementation.
 * 
 * @author suwimont
 *
 */
public class BSTAbst {

    /**
     * The root.
     */
    //Node root;
    static Random r = new Random();

    static boolean ndet() {
        return r.nextBoolean();
    }
    int gNodeId = 0;

    synchronized int getLastNodeId() {
        return gNodeId;
    }

    synchronized void incGNodeId() {
        gNodeId++;
    }

    /**
     * Constructs a tree.
     */
    public BSTAbst() {
        //root = new Node(Integer.MAX_VALUE);
    }

    /**
     * Recursively finds a node with value <code>v</code> 
     * from the node <code>n</code>.
     * 
     * @param n the node in which the value is looked for.
     * @param v the value.
     * @return the parent of the node with value <code>v</code>.
     */
    private int find(int v) {
        int nodeid = getLastNodeId();
        boolean recur = ndet();
        if (recur) {
            return find(v);
        } else {
            lock();
            if (nodeid != getLastNodeId()) {
                unlock();
                return find(v);
            }
            return nodeid;
        }
    }

    /**
     * Searches for the node with value <code>v</code>
     * 
     * @param v the value.
     * @return the node.
     */
    public void search(int v) {
        int nodeid = find(v);
        assert (nodeid==getLastNodeId());
        unlock();
    }

    /**
     * Inserts a node with value <code>v</code> into the tree.
     * 
     * @param v the value.
     */
    public void insert(int v) {
        int nodeid = find(v);
        if (ndet()) {
            unlock();	// node already exists
        } else {
            assert (nodeid==getLastNodeId());            
            incGNodeId();
            unlock();
        }
    }
    boolean lock;

    synchronized void lock() {
        while (lock) {
            try {
                wait();
            } catch (InterruptedException e) {
            }
        }
        lock = true;
    }

    synchronized void unlock() {
        lock = false;
        notify();
    }

    /**
     * A jMoped test method.
     * 
     * Suggested parameters: 6/35/2/3
     * 
     * @param x the value to be inserted in the tree.
     */
    public static void main(String[] args) {
        final BSTAbst tree = new BSTAbst();

        tree.insert(2);
        new Thread(new Runnable() {

            public void run() {
                tree.search(1);
            }
        }).start();
        tree.search(3);
    }
}
