%
% The first version of the bluetooth example as published in 
% Dejvuth Suwimonteerabuth, Javier Esparza, Stefan Schwoon: Symbolic Context-Bounded Analysis of Multithreaded Java Programs, Spin 08
%
% The pattern directly leads to the error.
%
%

cfGrmRules(R):-
  R = [

    %inc
    rule(inc0,term(item(d,stopFlag)==true),inc1),
      rule(inc1,term(status=(-1)),inc2),
      rule(inc2,eps),
    rule(inc0,term(item(d,stopFlag)==false),inc3),
    rule(inc3,term(lock(d)),inc4),
      rule(inc4,term(inc(item(d,pendingIo))),inc5),
    rule(inc5,term(unlock(d)),inc6),
    rule(inc6,term(status=0),inc7),
    rule(inc7,eps),

    %dec
    rule(dec0,term(lock(d)),dec1),
      rule(dec1,term(dec(item(d,pendingIo))),dec2),
      rule(dec2,term(pio=item(d,pendingIo)),dec3),
    rule(dec3,term(unlock(d)),dec4),
    rule(dec4,term(pio==0),dec5),rule(dec4,term(not(pio==0)),dec6),
      rule(dec5,term(item(d,stopEvent)=true),dec6),
    rule(dec6,eps)
  ]
  . 

memDefinition(MD):-
  MD = memDef(
  [ mutex-d,
    int(-1,2)-item(d,pendingIo)=1,
    bool-item(d,stopFlag),
    bool-item(d,stopEvent),
    bool-item(d,stopped)
  ],
  [ int(-1,2)-status,
    int(-1,2)-pio
  ],
  [ pio=item(d,pendingIo)]
  ).

 

threads(THREADS):-
  cfGrmRules(INCDECRULES),
  memDefinition(MEMDEF),
  THREADS= [
    thread(0,cfGrm(z(add0),[
      %add
      rule(add0,inc0,add1), %status is not a stack variable. Instead it is a local one. No returns and assignments.
      rule(add1,term(status==0),add2),rule(add1,term(not(status==0)),add3),
        rule(add2,term(item(d,stopped)==false),add3),
        rule(add2,term(item(d,stopped)==true),assertFailed),
        rule(assertFailed,term(assert(false)),assertFailed),
      rule(add3,dec0,add4)
    |INCDECRULES]),MEMDEF ),
    thread(1,cfGrm(z(stop0),[
      %stop
      rule(stop0,term(item(d,stopFlag)=true),stop1),
      rule(stop1,dec0,stop2),
      rule(stop2,term(item(d,stopEvent)==false),stop2),
      rule(stop2,term(item(d,stopEvent)==true),stop3),
      rule(stop3,term(item(d,stopped)=true),stop4),
      rule(stop4,eps)
    |INCDECRULES]),MEMDEF)
  ].

pattern(P):-P=[[go(0)],[yield(g(unlocked,1,false,false,false))],[go(1)],[yield(g(unlocked,0,true,true,true))],[go(0)],
               [yield(errmem),go(1)]].
