:-include(main).



testIntersectRules:-cfgrammar(CFGR),reggrammar(REGGR),intersectRules(CFGR,REGGR,OUT),writeList(OUT).

testGrammarChain(HOMO,RESULT):-
    cfgrammar(CFGR),reggrammar(REGGR),pattern(PATTERN),
    grammarChainDBG(0,CFGR,REGGR,PATTERN,HOMO,RESULT).

grammarChainDBG(TID,CTRLFLOWGR,MEMGR,PATTERN,HOMO,RESULTRULES):-
    intersectRules(CTRLFLOWGR,MEMGR,CTRLFLMEMGR),
    write(ctrlflow+memory),nl,writeList(CTRLFLMEMGR),nl,
    generateCtxRules(TID,CTRLFLMEMGR,CTXSWGR),
    append(CTRLFLMEMGR,CTXSWGR,MULTITHREADEDGRM),
    write(ctrlflow+memory+ctxswitch),nl,writeList(MULTITHREADEDGRM),nl,
    projection(MULTITHREADEDGRM,ctxs,ONLYSWITCHESGRM),
    write(afterProjection),nl,writeList(ONLYSWITCHESGRM),nl,
    patternToRules(PATTERN,_,PATTERNRULES),
    write(pattern),nl,writeList(PATTERNRULES),nl,
    intersectRules(ONLYSWITCHESGRM,PATTERNRULES,PTRNINTERSECTRULES),
    write(intersect),nl,writeList(PTRNINTERSECTRULES),nl,
    (HOMO=homo->
      patternHomomorph(PTRNINTERSECTRULES,HOMOMORPH),
      write(homomorph),nl,writeList(HOMOMORPH),nl
    ;
    HOMOMORPH=PTRNINTERSECTRULES
    ),
    append(MEMGR,PATTERNRULES,REGGRMS),
    append(REGGRMS,HOMOMORPH,RESULTRULES1),
    write(result),nl,writeList(RESULTRULES1),nl,
    sortClauseBodies(RESULTRULES1,RESULTRULES),
    write(sortedresult),nl,writeList(RESULTRULES),nl.

%testGenerateWords(HOMO,W):-
%    cfgrammar(CFGR),reggrammar(REGGR),pattern(PATTERN),
%    grammarChain(0,CFGR,REGGR,PATTERN,HOMO,GRM),
    %writeList(GRM),
    %constructInitState(k,s(g(0),l(0)),INIT),
    %write(INIT),
%    generateWords(GRM,INIT,W).




testGenerate2(X):-
  instgrm(GRM),
  generateWords(GRM,n0,X).

testGenerateEquations:-
  instgrm(RULES),
  nonterms(NT),
  terms(TERMS),
  generateEquation(n0,NT,TERMS,RULES,EQLIST,TERMVARS,RULEVARS,REACHTKMAP),
  groundEquation(TERMS,TERMVARS,RULEVARS,REACHTKMAP),
  writeList(EQLIST).

testSolveEquations:-
  instgrm(RULES),
  nonterms(NT),
  terms(TERMS),
  generateEquation(n0,NT,TERMS,RULES,EQLIST,TERMVARS,RULEVARS,REACHTKMAP),
  conjunction(EQLIST,EQ),
  clpSolveEquation(50,EQ,TERMVARS,RULEVARS,REACHTKMAP),
  presentResult(TERMS,TERMVARS,RULEVARS,REACHTKMAP).

testPkImage(TERMVARS,RULEVARS,REACHTKMAP):-
  instgrm(RULES),
  getTerminalsAndNonterminals(RULES,TERMS,NT),
  generateEquation(l0,NT,TERMS,RULES,EQLIST,TERMVARS,RULEVARS,REACHTKMAP),
  assoc_to_values(REACHTKMAP,REACHVARS),
  conjunction(EQLIST,EQ),
  clpSolveEquation(50,EQ,TERMVARS,RULEVARS,REACHVARS,ok).

testPkImage2(TERMVARS,RULEVARS,REACHTKMAP):-
  instgrm(RULES),
  getTerminalsAndNonterminals(RULES,TERMS,NT),
  generateEquation(l0,NT,TERMS,RULES,EQLIST,TERMVARS,RULEVARS,REACHTKMAP),
  assoc_to_values(REACHTKMAP,REACHVARS),
  
  groundEquation(TERMS,TERMVARS,RULEVARS,[l0],REACHTKMAP),
  writeList(EQLIST),
  writeList(TERMVARS),
  writeList(RULEVARS),
  writeList(REACHVARS).

